/****************************************************************************/
/*                                                                          */
/*  Ui_DialogSelect.c :  Fentre de slection de la fentre cible.          */
/*                                                                          */
/****************************************************************************/
/*  Auteur : Franois GAUTHIER   *   Cooperteam   *   Date : Septembre 2010 */
/****************************************************************************/

#include <windows.h>
#include <commctrl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Dc_Shared.h"
#include "Dc_Memory.h"
#include "Dc_Window.h"
#include "resource.h"
#include "Ui_DialogSelect.h"
#include "Ui_DialogSettings.h"
#include "Ui_DialogMain.h"

BOOL CALLBACK SelectDialogProc(HWND,UINT,WPARAM,LPARAM);

/****************************************************************************/
/*  Show_Picture_Selection_Window() :  Cration de la fentre de slection. */
/****************************************************************************/
int ShowPictureSelectionWindow(HWND Param1)
{
  HINSTANCE hInstance;
  HWND hDialog;
  HWND hSelectWin;
  
  my_Windows(WINDOWS_GET_HDIALOGMAIN,&hDialog,NULL);
  my_Windows(WINDOWS_GET_INSTANCE,&hInstance,NULL);
  
  /* Creation de la fentre et rcupration du handle de celle-ci */
  hSelectWin = CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG2),hDialog,(DLGPROC)SelectDialogProc);
 
  /* Affichage de la fentre */
  ShowWindow(hSelectWin,SW_SHOW);

  /* Positionne la fentre */
  SetWindowPos(hSelectWin,HWND_TOP,540,381,-1,-1,SWP_NOSIZE);
  
  return(0);
}


/*****************************************************************************/
/*  SelectDialogProc() :  Fonction de traitement des messages de la fentre. */
/*****************************************************************************/
BOOL CALLBACK SelectDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  HWND hwndList;
  HWND hDialog;
  HWND hDialog_settings;
  int i, nb_windowtitle, position;
  struct window_title *current_window;
  struct window_settings *current_settings;
  char buffer[1024];

  switch(message)
    {
      case WM_INITDIALOG :
        /* Stockage du handle de la ListBox */
        hwndList = GetDlgItem(hDlg,IDC_LIST1);

        /** Rcupration des fentres **/
        my_Memory(MEMORY_GET_WINDOWTITLE_NB,&nb_windowtitle,NULL);
        for(i=1; i<=nb_windowtitle; i++)
          {
            my_Memory(MEMORY_GET_WINDOWTITLE,&i,&current_window);
            if(current_window != NULL)
              {
                position = (int)SendMessage(hwndList, LB_ADDSTRING, 0,(LPARAM) current_window->title);
                SendMessage(hwndList, LB_SETITEMDATA, position, (LPARAM)i); 
              }
          }
        SetFocus(hwndList);
      break;

      case WM_COMMAND:
        if(LOWORD(wParam) == ID_OK_SELECT)
          { 
            /* Stocke la fentre slectionne */
            hwndList = GetDlgItem(hDlg,IDC_LIST1);
            i = (int)SendMessage(hwndList,LB_GETCURSEL,0,0);
            i++;
            my_Memory(MEMORY_GET_WINDOWTITLE,&i,&current_window);
            my_Windows(WINDOWS_GET_HDIALOGMAIN,&hDialog,NULL);
            my_Windows(WINDOWS_GET_HDIALOGSETTINGS,&hDialog_settings,NULL);
            if(current_window != NULL)
              {
                /* Renseigne le champ target window */
                SetWindowText(GetDlgItem(hDialog_settings,IDC_TARGET_WINDOW),current_window->title);

                /* Taille de la fentre */
                sprintf(buffer,"%dx%d",current_window->delta_rc_window_width,current_window->delta_rc_window_height);
                SetWindowText(GetDlgItem(hDialog_settings,IDC_STATIC_WINDOWSIZEVALUE),buffer);

                /* Taille de la zone client */
                sprintf(buffer,"(%dx%d)",current_window->delta_rc_client_width,current_window->delta_rc_client_height);
                SetWindowText(GetDlgItem(hDialog_settings,IDC_STATIC_CLIENTSIZEVALUE),buffer);

                /* Dimension de la zone  capturer */
                my_Memory(MEMORY_GET_WINDOWSETTINGS,&current_settings,NULL);
                UpdatePictureSize(hDialog_settings,current_window,current_settings);

                /* Stocke la fentre active */
                my_Memory(MEMORY_SET_ACTIVEWINDOW,&i,&current_window);

                /* Retabli l'option Set-TopMost */
                my_Button(CHECKBOX_TOPMOST_ON,hDialog_settings);
              }
            else
              SetWindowText(GetDlgItem(hDialog_settings,IDC_TARGET_WINDOW),"Please select a window");

            my_Button(BUTTON_SELECTWINDOW_ON,hDialog_settings);
            EndDialog(hDlg,0);
          }
      break;

      default:
        return(FALSE);
    }
  return(TRUE);
}

/*************************************************************************************/